local prevfile = require "prevfile"

local nextfile = {}

function nextfile.splitfilename(path)
	dir, name, ext = path:match("^(.*/)(.*)(%.%w*)")
	return dir, name, ext
end

function nextfile.nextletter(letter)
	if letter == "z" then return "za" end

	local ascii = letter:byte()
	local nextascii = ascii + 1
	return string.char(nextascii)
end

function nextfile.nextfile(directory)
	local previous = prevfile.prevfile(directory)
	if previous == nil then return nil end

	local dir, name, ext = nextfile.splitfilename(previous)

	if tonumber(name) == nil then
		local lastletter = name:sub(#name)
		local nextletter = nextfile.nextletter(lastletter)
		return dir .. name:gsub(lastletter .. "$", nextletter) .. ext
	end
	
	return dir .. name + 1 .. ext
end

return nextfile
